/*******************************************************************************
*   Author       -  Kiraly Tibor
*                   www.tkiraaly.hu
*   Date         -  2016.03.20.
*   Chip         -  ATmega8
*   Compiler     -  avr-gcc (WinAVR)
*
*   Jelzo lampa - cpp demo
*
*******************************************************************************/
#define F_CPU                4 MHZ




#include "tkiraaly_atmega8.h"
#include "tkiraaly_kbutton.cpp"
#include "tkiraaly_kled.cpp"




int main( void)
{
   U8 phase= 0;                        // jelzolampa fazis
   kled lamp_red( D_PORT_5);           // piros lampa
   kled lamp_yellow( D_PORT_6);        // sarga lampa
   kled lamp_green( D_PORT_7);         // zold lampa
   lamp_red.on();
   kbutton button_step( D_PORT_2);     // lepteto gomb
   for(;;)
   {
      if( button_step.check())
      {
         phase++;
         if( phase > 3) phase= 0; 
         switch( phase)
         {
            case 0:                    // piros
                    lamp_red.on();
                    lamp_yellow.off();
                    break;
            
            case 1:                    // piros + sarga
                    lamp_yellow.on();
                    break;
            case 2:                    // zold
                    lamp_red.off();
                    lamp_yellow.off();
                    lamp_green.on();
                    break;
            case 3:                    // sarga
                    lamp_yellow.on();
                    lamp_green.off();
                    break;
         }
      }
   }
}
